import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ScrollPaneConstants;

import java.util.Random;

/**
 * Applications réparties
 * TP 1
 * Chat, Sockets
 *
 * IHM pour l'application cliente
 *
 * @author Toto
 * @version 1.0
 */
public class IHM implements ActionListener {

    private JTextArea entrants;
    private JTextField sortants;
    private ArrayList<String> sendMessages;
    //FIXME: use a random name by thread for now, should be setable
    private String randName;

    IHM() {
        sendMessages = new ArrayList<String>();
        randName = randomName();
    }

    private String randomName() {

        int leftLimit = 97; // letter 'a'
        int rightLimit = 122; // letter 'z'
        int targetStringLength = 8;
        Random random = new Random();
        StringBuilder buffer = new StringBuilder(targetStringLength);
        for (int i = 0; i < targetStringLength; i++) {
            int randomLimitedInt = leftLimit + (int)(random.nextFloat() * (rightLimit - leftLimit + 1));
            buffer.append((char)randomLimitedInt);
        }
        String generatedString = buffer.toString();

        return generatedString;
    }

    public void go() {
        JFrame cadre = new JFrame("Client de discussion de " + randName);
        JPanel panneau = new JPanel();
        entrants = new JTextArea(15, 30);
        entrants.setLineWrap(true);
        entrants.setWrapStyleWord(true);
        entrants.setEditable(false);
        JScrollPane zoneTexte = new JScrollPane(entrants);
        zoneTexte.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        zoneTexte.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        sortants = new JTextField(24);
        JButton boutonEnvoi = new JButton("Envoi");
        boutonEnvoi.addActionListener(this);
        panneau.add(zoneTexte);
        panneau.add(sortants);
        panneau.add(boutonEnvoi);
        cadre.getContentPane().add(BorderLayout.CENTER, panneau);
        cadre.setSize(400, 310);
        cadre.setVisible(true);

        panneau.setLayout(new BoxLayout(panneau, BoxLayout.Y_AXIS));
        cadre.pack();
    } // fin methode go

    synchronized public void actionPerformed(ActionEvent ev) {
        sendMessages.add(sortants.getText());
        sortants.setText("");
        sortants.requestFocus();
        this.notify();
    }

    synchronized public String getNextMessageToSend() {
        try {
            if (sendMessages.isEmpty())
                this.wait();
            }
        catch (Exception e) {
            System.err.println("Exception : " + e);
            e.printStackTrace();
        }
        String mess = (String)sendMessages.remove(0);
        if (mess.length() == 0)
            return "";
        System.out.println("IHM -> message a envoyer : " + mess);
        return randName + "> " + mess;
    }

    public void writeMessage(String mess) {
        System.out.println("IHM -> message a ecrire : " + mess);
        entrants.append(mess + "\n");
    }

} // fin classe SimpleClientDiscussion
