import java.io.*;


public class Main {

	/**
	 * main for testing ClientSimplifie
	 */
	private static void main1() {
		ClientSimplifie client = null;
		BufferedReader userInput = null;

		try {
			client = new ClientSimplifie();
			userInput = new BufferedReader(new InputStreamReader(System.in));
			boolean end = false;
			while (!end) {
				String line = userInput.readLine();
				if (line.equals("."))
					end = true;
				client.sendMsg(line);
				String rline = client.receiveMsg();
				System.out.println(rline);
			}
		}
		catch (IOException e) {
			System.err.println("IOException: " + e);
		}
		finally {
			client.closeRWIO();
			if (userInput != null) {
				try {
					userInput.close();
				}
				catch (IOException e) {
					System.err.println("IOException: " + e);
				}
			}
		}
	}

	/**
	 * main for text based message broadcasting
	 */
	public static void main2() {
		SocketClient client = null;
		Thread thS = null;
		Thread thR = null;

		try {
			client = new SocketClient();
			thS = new Thread(new ThreadClientSend(client));
			thR = new Thread(new ThreadClientReceive(client));
			thS.setName("thS");
			thS.start();
			thR.setName("thR");
			thR.start();
		}
		catch (Exception e) {
			System.err.println("Exception: " + e);
		}
		finally {
			try {
				thS.join();
				thR.join();
			}
			catch (InterruptedException e) {
				System.err.println("InterruptedException: " + e);
				e.printStackTrace();
			}
			client.closeRWIO();
		}
	}

	public static void main(String[] args) {
		SocketClient client = null;
		Thread thS = null;
		Thread thR = null;

		try {
			client = new SocketClient(true);
			thS = new Thread(new ThreadClientoSend(client));
			thR = new Thread(new ThreadClientoReceive(client));
			thS.setName("thoS");
			thS.start();
			thR.setName("thoR");
			thR.start();
		}
		catch (Exception e) {
			System.err.println("Exception: " + e);
		}
		finally {
			try {
				thS.join();
				thR.join();
			}
			catch (InterruptedException e) {
				System.err.println("InterruptedException: " + e);
				e.printStackTrace();
			}
			client.closeRWIO();
		}
	}

}
