import java.io.Serializable;
import java.util.Calendar;
import java.text.SimpleDateFormat;

public class Message implements Serializable {
    // L'emeteur du message
    private String emetteur;
    // Le contenu du message
    private String texte;
    // Heure du message
    private Calendar heure;
    private static final long serialVersionUID = 1L;

    // Les méthodes

    Message(String name, String msg, Calendar c) {
        emetteur = name;
        texte = msg;
        heure = c;
    }

    /**
     * @param name the emetteur to set
     */
    public void setEmetteur(String name) {
        emetteur = name;
    }

    /**
     * @return the emetteur
     */
    public String getEmetteur() {
    	return emetteur;
    }

    /**
     * @param texte the texte to set
     */
    public void setTexte(String texte) {
    	this.texte = texte;
    }

    /**
     * @return the texte
     */
    public String getTexte() {
    	return texte;
    }

    /**
     * @param heure the heure to set
     */
    public void setHeure(Calendar heure) {
    	this.heure = heure;
    }

    /**
     * @return the heure
     */
    public Calendar getHeure() {
    	return heure;
    }

    public String toString() {
        SimpleDateFormat dateFormat = new SimpleDateFormat("HH:mm:ss");
        return "<" + emetteur + "|" + dateFormat.format(heure.getTime()) + "> " + texte;
    }
}
